from collections import UserList
import os

from sqlalchemy import case

from auth import login_required, bp as auth_bp
from deck import get_deck, bp as deck_bp
from flask import Flask, render_template, session, request

from create_db import Card
from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker
from config import CONFIG 

engine = create_engine(CONFIG['DB_CONNECTION'])
dbsessionmaker = sessionmaker(bind=engine)
dbsession = dbsessionmaker()


def create_app(test_config=None):
    # create and configure the app
    app = Flask(__name__, instance_relative_config=True)
    app.config.from_mapping(
        SECRET_KEY='dev',
        DATABASE=os.path.join(app.instance_path, 'flaskr.sqlite'),
    )                                                                # = kaj naj tu piše?

    if test_config is None:
        # load the instance config, if it exists, when not testing
        app.config.from_pyfile('config.py', silent=True)
    else:
        # load the test config if passed in
        app.config.from_mapping(test_config)

    # ensure the instance folder exists
    try:
        os.makedirs(app.instance_path)
    except OSError:
        pass


    @app.route('/')
    @login_required
    def index():
        return 'redirecting' # meče skoz nazaj na login TODO

    #@login_required
    @app.route('/deck/index', methods=("GET", "POST"))
    def deck():
        if 'user_id' in session:
            user_id = session['user_id']
            username = session['username']
            d = get_deck(user_id)
            
            for card in d: #TODO to ne dela, nevem kako renderat zapooredno kartic
                if request.method == 'POST':
                    rate = request.form['rate']
                    cardtitle = request
                    print(rate)
                    if rate == "Yes":
                        k = 1
                    elif rate == "Maybe":
                        k = 0.5
                    elif rate == "No":
                        k = 0.1

        
                    print(card.id)
                    print(user_id)
                    dbsession.query(Card).filter(Card.id == card.id).update({'interest_rate': abs(card.interest_rate*k)}) #TODO 1 mora nastavit na 1
                    dbsession.commit()  
                    render_template("deck/index.html", username=username, card = card)
                return render_template("deck/index.html", username=username, card = card) # no idea kaj se tu dogaja...
        else:
            return index()


    @app.route('/logout')
    def logout():
        session.pop("user_id", None)
        return index()


    #app.register_blueprint(bp) # ??
    
    app.register_blueprint(auth_bp)
    app.register_blueprint(deck_bp)
    app.add_url_rule('/', endpoint='index')

    return app


app = create_app()
app.run(debug=True, host="0.0.0.0")