from flask import (
    Blueprint, flash, g, redirect, render_template, request, url_for, session
)

from werkzeug.exceptions import abort

from auth import login_required
from create_db import Card, User

from config import CONFIG

from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker

bp = Blueprint('deck', __name__)

engine = create_engine(CONFIG['DB_CONNECTION'])
dbsessionmaker = sessionmaker(bind=engine)
dbsession = dbsessionmaker()

@bp.route('/deck', methods=['GET'])
# @login_required
def get_deck(user_id):

    user_collection = dbsession.query(Card).filter(Card.owner_id == user_id).all()

    return user_collection